#include "stdafx.h"

extern COLORCOMBINE colorCombine;
extern CONSTANTCOLOR constantColor;
extern TEXCOMBINE texCombine;
extern ALPHACOMBINE alphaCombine;
extern BLEND blend;
extern GLenum glFunc;
extern DEPTHINFO depthInfo;

extern int texWidth, texHeight;
extern FxU32 curStartAddress;
extern GrTexInfo curTexInfo;
extern GLbyte texMem[4 * 1024 * 1024];

void displayAlphaInfo(void)
{
   char string[256];
   char d[256];

   strcpy(string, "grAlphaCombine\n");
   strcat(string, itoa(alphaCombine.func, d, 10));
   strcat(string, "\n");
   strcat(string, itoa(alphaCombine.factor, d, 10));
   strcat(string, "\n");
   strcat(string, itoa(alphaCombine.local, d, 10));
   strcat(string, "\n");
   strcat(string, itoa(alphaCombine.other, d, 10));
   strcat(string, "\n");
   strcat(string, itoa(alphaCombine.invert, d, 10));

   MessageBox(NULL, string, "Notice", MB_APPLMODAL);
}

extern "C" __declspec(dllexport)
void grDrawTriangle(const GrVertex *a, const GrVertex *b, const GrVertex *c)
{
   int tmu = 0;

   float ar = a->r / 255.0f;
   float ag = a->g / 255.0f;
   float ab = a->b / 255.0f;
   float aa = a->a / 255.0f;
   float aw = 1.0f / a->oow;
   float ax = a->x * aw;
   float ay = a->y * aw;
   float az = ((*(unsigned long*)&aw >> 11) - (127 << 12))/ 65535.0f * aw;
   float as = (a->tmuvtx[tmu].sow / a->oow) / texWidth;
   float at = (a->tmuvtx[tmu].tow / a->oow) / texHeight;

   float br = b->r / 255.0f;
   float bg = b->g / 255.0f;
   float bb = b->b / 255.0f;
   float ba = a->a / 255.0f;
	float bw = 1.0f / b->oow;
   float bx = b->x * bw;
   float by = b->y * bw;
   float bz = ((*(unsigned long*)&bw >> 11) - (127 << 12)) / 65535.0f * bw;
   float bs = (b->tmuvtx[tmu].sow * bw) / texWidth;
   float bt = (b->tmuvtx[tmu].tow * bw) / texHeight;
	
   float cr = c->r / 255.0f;
   float cg = c->g / 255.0f;
   float cb = c->b / 255.0f;
   float ca = a->a / 255.0f;
   float cw = 1.0f / c->oow;
   float cx = c->x * cw;
   float cy = c->y * cw;
   float cz = ((*(unsigned long*)&cw >> 11) - (127 << 12)) / 65535.0f * cw;
   float cs = (c->tmuvtx[tmu].sow * cw) / texWidth;
   float ct = (c->tmuvtx[tmu].tow * cw) / texHeight;
/////////////////////////////////////
/////////////////////////////////////
/////////////////////////////////////
   if(colorCombine.func == GR_COMBINE_FUNCTION_SCALE_OTHER &&
		colorCombine.factor == GR_COMBINE_FACTOR_ONE &&
		colorCombine.other == GR_COMBINE_OTHER_TEXTURE)
   {
      glEnable(GL_TEXTURE_2D);
   	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
      glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
      glBegin(GL_TRIANGLES);
         glTexCoord2f(as, at);
		   glVertex4f(ax, ay, az, aw);

         glTexCoord2f(bs, bt);
		   glVertex4f(bx, by, bz, bw);

         glTexCoord2f(cs, ct);
		   glVertex4f(cx, cy, cz, cw);
      glEnd();
      glDisable(GL_TEXTURE_2D);
      return;
   }

/////////////////////////////////////
/////////////////////////////////////
/////////////////////////////////////
   if(colorCombine.func == GR_COMBINE_FUNCTION_SCALE_OTHER &&
		colorCombine.factor == GR_COMBINE_FACTOR_LOCAL &&
		colorCombine.other == GR_COMBINE_OTHER_TEXTURE &&
		colorCombine.local == GR_COMBINE_LOCAL_ITERATED)
   {
      if(alphaCombine.func == GR_COMBINE_FUNCTION_SCALE_OTHER &&
         alphaCombine.factor == GR_COMBINE_FACTOR_LOCAL &&
         alphaCombine.local == GR_COMBINE_LOCAL_ITERATED &&
         alphaCombine.other == GR_COMBINE_OTHER_TEXTURE)
      {
         glEnable(GL_TEXTURE_2D);
   	   glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
         glBegin(GL_TRIANGLES);
		      glColor4f(ar, ag, ab, aa);
            glTexCoord2f(as, at);
		      glVertex4f(ax, ay, az, aw);
		      
		      glColor4f(br, bg, bb, ba);
            glTexCoord2f(bs, bt);
		      glVertex4f(bx, by, bz, bw);

		      glColor4f(cr, cg, cb, ca);
            glTexCoord2f(cs, ct);
		      glVertex4f(cx, cy, cz, cw);
	      glEnd();
         glDisable(GL_TEXTURE_2D);
         return;
      }

      if(alphaCombine.func == GR_COMBINE_FUNCTION_SCALE_OTHER &&
         alphaCombine.factor == GR_COMBINE_FACTOR_ONE &&
         alphaCombine.other == GR_COMBINE_OTHER_TEXTURE)
      {
         glEnable(GL_TEXTURE_2D);
   	   glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
         glBegin(GL_TRIANGLES);
		      glColor4f(ar, ag, ab, 1.0f);
            glTexCoord2f(as, at);
		      glVertex4f(ax, ay, az, aw);
		      
		      glColor4f(br, bg, bb, 1.0f);
            glTexCoord2f(bs, bt);
		      glVertex4f(bx, by, bz, bw);

		      glColor4f(cr, cg, cb, 1.0f);
            glTexCoord2f(cs, ct);
		      glVertex4f(cx, cy, cz, cw);
	      glEnd();
         glDisable(GL_TEXTURE_2D);
         return;
      }

      if(alphaCombine.func == GR_COMBINE_FUNCTION_LOCAL &&
         alphaCombine.local == GR_COMBINE_LOCAL_ITERATED)
      {
         glDisable(GL_ALPHA_TEST);//hack for zelda
         glEnable(GL_TEXTURE_2D);
   	   glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
         glBegin(GL_TRIANGLES);
		      glColor4f(ar, ag, ab, aa);
            glTexCoord2f(as, at);
		      glVertex4f(ax, ay, az, aw);

		      glColor4f(br, bg, bb, ba);
            glTexCoord2f(bs, bt);
		      glVertex4f(bx, by, bz, bw);

		      glColor4f(cr, cg, cb, ca);
            glTexCoord2f(cs, ct);
		      glVertex4f(cx, cy, cz, cw);
         glEnd();
         if(glFunc != GL_ALWAYS) glEnable(GL_ALPHA_TEST);//hack
         glDisable(GL_TEXTURE_2D);
         return;
      }
      
      if(alphaCombine.func == GR_COMBINE_FUNCTION_LOCAL &&
         alphaCombine.local == GR_COMBINE_LOCAL_CONSTANT)
      {
         glEnable(GL_TEXTURE_2D);
   	   glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
         glBegin(GL_TRIANGLES);
		      glColor4f(ar, ag, ab, constantColor.a);
            glTexCoord2f(as, at);
		      glVertex4f(ax, ay, az, aw);

		      glColor4f(br, bg, bb, constantColor.a);
            glTexCoord2f(bs, bt);
		      glVertex4f(bx, by, bz, bw);

		      glColor4f(cr, cg, cb, constantColor.a);
            glTexCoord2f(cs, ct);
		      glVertex4f(cx, cy, cz, cw);
         glEnd();
         glDisable(GL_TEXTURE_2D);
         return;
      }

      displayAlphaInfo();
      return;
   }
/////////////////////////////////////
/////////////////////////////////////
/////////////////////////////////////
   if(colorCombine.func == GR_COMBINE_FUNCTION_LOCAL &&
      colorCombine.local == GR_COMBINE_LOCAL_CONSTANT)
   {
      ar = br = cr = constantColor.r;
      ag = bg = cg = constantColor.g;
      ab = bb = cb = constantColor.b;

      if(alphaCombine.func == GR_COMBINE_FUNCTION_SCALE_OTHER &&
         alphaCombine.factor == GR_COMBINE_FACTOR_LOCAL &&
         alphaCombine.local == GR_COMBINE_LOCAL_ITERATED &&
         alphaCombine.other == GR_COMBINE_OTHER_TEXTURE)
      {
         //zelda press start
         glEnable(GL_TEXTURE_2D);
   	   glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
         glBegin(GL_TRIANGLES);
		      glColor4f(ar, ag, ab, aa);
            glTexCoord2f(as, at);
		      glVertex4f(ax, ay, az, aw);
		      
		      glColor4f(br, bg, bb, ba);
            glTexCoord2f(bs, bt);
		      glVertex4f(bx, by, bz, bw);

		      glColor4f(cr, cg, cb, ca);
            glTexCoord2f(cs, ct);
		      glVertex4f(cx, cy, cz, cw);
	      glEnd();
         glDisable(GL_TEXTURE_2D);
         return;
      }

      if(alphaCombine.func == GR_COMBINE_FUNCTION_SCALE_OTHER &&
         alphaCombine.factor == GR_COMBINE_FACTOR_ONE &&
         alphaCombine.other == GR_COMBINE_OTHER_TEXTURE)
      {
         //zelda letters (entering name)
         glEnable(GL_TEXTURE_2D);
   	   glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
         glBegin(GL_TRIANGLES);
		      glColor4f(ar, ag, ab, 1.0f);
            glTexCoord2f(as, at);
		      glVertex4f(ax, ay, az, aw);
		      
		      glColor4f(br, bg, bb, 1.0f);
            glTexCoord2f(bs, bt);
		      glVertex4f(bx, by, bz, bw);

		      glColor4f(cr, cg, cb, 1.0f);
            glTexCoord2f(cs, ct);
		      glVertex4f(cx, cy, cz, cw);
	      glEnd();
         glDisable(GL_TEXTURE_2D);
         return;
      }

      if(alphaCombine.func == GR_COMBINE_FUNCTION_LOCAL &&
         alphaCombine.local == GR_COMBINE_LOCAL_ITERATED)
      {
         glBegin(GL_TRIANGLES);
		      glColor4f(ar, ag, ab, aa);
		      glVertex4f(ax, ay, az, aw);
		      
		      glColor4f(br, bg, bb, ba);
		      glVertex4f(bx, by, bz, bw);

		      glColor4f(cr, cg, cb, ca);
		      glVertex4f(cx, cy, cz, cw);
	      glEnd();
         return;
      }

      displayAlphaInfo();
      return;
   }

/////////////////////////////////////
/////////////////////////////////////
/////////////////////////////////////
   if(colorCombine.func == GR_COMBINE_FUNCTION_LOCAL &&
      colorCombine.local == GR_COMBINE_LOCAL_ITERATED)
   {
      if(alphaCombine.func == GR_COMBINE_FUNCTION_SCALE_OTHER &&
         alphaCombine.factor == GR_COMBINE_FACTOR_LOCAL &&
         alphaCombine.local == GR_COMBINE_LOCAL_ITERATED &&
         alphaCombine.other == GR_COMBINE_OTHER_TEXTURE)
      {
         //zelda press start (not quite right)
         glEnable(GL_TEXTURE_2D);
   	   glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
         glBegin(GL_TRIANGLES);
		      glColor4f(ar, ag, ab, aa);
            glTexCoord2f(as, at);
		      glVertex4f(ax, ay, az, aw);
		      
		      glColor4f(br, bg, bb, ba);
            glTexCoord2f(bs, bt);
		      glVertex4f(bx, by, bz, bw);

		      glColor4f(cr, cg, cb, ca);
            glTexCoord2f(cs, ct);
		      glVertex4f(cx, cy, cz, cw);
	      glEnd();
         glDisable(GL_TEXTURE_2D);
         return;
      }

      if(alphaCombine.func == GR_COMBINE_FUNCTION_SCALE_OTHER &&
         alphaCombine.factor == GR_COMBINE_FACTOR_ONE &&
         alphaCombine.other == GR_COMBINE_OTHER_TEXTURE)
      {
         //zelda letters (entering name)
         glEnable(GL_TEXTURE_2D);
   	   glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
         glBegin(GL_TRIANGLES);
		      glColor4f(ar, ag, ab, 1.0f);
            glTexCoord2f(as, at);
		      glVertex4f(ax, ay, az, aw);
		      
		      glColor4f(br, bg, bb, 1.0f);
            glTexCoord2f(bs, bt);
		      glVertex4f(bx, by, bz, bw);

		      glColor4f(cr, cg, cb, 1.0f);
            glTexCoord2f(cs, ct);
		      glVertex4f(cx, cy, cz, cw);
	      glEnd();
         glDisable(GL_TEXTURE_2D);
         return;
      }

      if(alphaCombine.func == GR_COMBINE_FUNCTION_LOCAL &&
         alphaCombine.local == GR_COMBINE_LOCAL_ITERATED)
      {
         glBegin(GL_TRIANGLES);
		      glColor4f(ar, ag, ab, aa);
		      glVertex4f(ax, ay, az, aw);
		      
		      glColor4f(br, bg, bb, ba);
		      glVertex4f(bx, by, bz, bw);

		      glColor4f(cr, cg, cb, ca);
		      glVertex4f(cx, cy, cz, cw);
	      glEnd();
         return;
      }

      displayAlphaInfo();
      return;
   }

/////////////////////////////////////
/////////////////////////////////////
/////////////////////////////////////
   if(colorCombine.func == GR_COMBINE_FUNCTION_SCALE_OTHER_MINUS_LOCAL_ADD_LOCAL &&
      colorCombine.factor == GR_COMBINE_FACTOR_LOD_FRACTION &&
      colorCombine.local == GR_COMBINE_LOCAL_ITERATED &&
      colorCombine.other == GR_COMBINE_OTHER_CONSTANT)
   {
      glDisable(GL_BLEND);
      glEnable(GL_TEXTURE_2D);
   	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
      glBegin(GL_TRIANGLES);
		   glColor4f(constantColor.r - ar, constantColor.g - ag, constantColor.g - ab, aa);
         glTexCoord2f(as, at);
		   glVertex4f(ax, ay, az, aw);
		   
		   glColor4f(constantColor.r - br, constantColor.g - bg, constantColor.g - bb, ba);
         glTexCoord2f(bs, bt);
		   glVertex4f(bx, by, bz, bw);

		   glColor4f(constantColor.r - cr, constantColor.g - cg, constantColor.g - cb, ca);
         glTexCoord2f(cs, ct);
		   glVertex4f(cx, cy, cz, cw);
	   glEnd();
      glDisable(GL_TEXTURE_2D);
      glEnable(GL_BLEND);
      glBlendFunc(GL_ONE, GL_ONE);
      glBegin(GL_TRIANGLES);
		   glColor4f(ar, ag, ab, aa);
		   glVertex4f(ax, ay, az, aw);
		   
		   glColor4f(br, bg, bb, ba);
		   glVertex4f(bx, by, bz, bw);

		   glColor4f(cr, cg, cb, ca);
		   glVertex4f(cx, cy, cz, cw);
	   glEnd();
      if(!blend.enabled) glDisable(GL_BLEND);
      glBlendFunc(blend.rgb_sf, blend.rgb_df);
  
      return;
      /*glEnable(GL_TEXTURE_2D);
   	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_BLEND);
      glTexEnvfv(GL_TEXTURE_ENV, GL_TEXTURE_ENV_COLOR, &constantColor.r);
      glBegin(GL_TRIANGLES);
		   glColor4f(ar, ag, ab, aa);
         glTexCoord2f(as, at);
		   glVertex4f(ax, ay, az, aw);
		   
		   glColor4f(br, bg, bb, ba);
         glTexCoord2f(bs, bt);
		   glVertex4f(bx, by, bz, bw);

		   glColor4f(cr, cg, cb, ca);
         glTexCoord2f(cs, ct);
		   glVertex4f(cx, cy, cz, cw);
	   glEnd();
      glDisable(GL_TEXTURE_2D);
      return;*/
   }

/////////////////////////////////////
/////////////////////////////////////
/////////////////////////////////////
   if(colorCombine.func == GR_COMBINE_FUNCTION_ZERO)
   {
	   glColor4f(0.0f, 0.0f, 0.0f, 0.0f);
      glBegin(GL_TRIANGLES);
		   glVertex4f(ax, ay, az, aw);
		   glVertex4f(bx, by, bz, bw);
		   glVertex4f(cx, cy, cz, cw);
      glEnd();
      return;
   }

/////////////////////////////////////
/////////////////////////////////////
/////////////////////////////////////
   if(colorCombine.func == GR_COMBINE_FUNCTION_SCALE_OTHER &&
		colorCombine.factor == GR_COMBINE_FACTOR_TEXTURE_ALPHA &&
		colorCombine.other == GR_COMBINE_OTHER_TEXTURE)
   {
      glEnable(GL_BLEND);
      glBlendFunc(GL_SRC_ALPHA, GL_ZERO);
      glEnable(GL_TEXTURE_2D);
   	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
      glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
      glBegin(GL_TRIANGLES);
         glTexCoord2f(as, at);
		   glVertex4f(ax, ay, az, aw);

         glTexCoord2f(bs, bt);
		   glVertex4f(bx, by, bz, bw);

         glTexCoord2f(cs, ct);
		   glVertex4f(cx, cy, cz, cw);
      glEnd();
      glDisable(GL_TEXTURE_2D);
      if(!blend.enabled) glDisable(GL_BLEND);
      glBlendFunc(blend.rgb_sf, blend.rgb_df);
      return;
      /*glEnable(GL_TEXTURE_2D);
   	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL);
      glColor4f(0.0f, 0.0f, 0.0f, 0.0f);
      glBegin(GL_TRIANGLES);
         glTexCoord2f(as, at);
		   glVertex4f(ax, ay, az, aw);

         glTexCoord2f(bs, bt);
		   glVertex4f(bx, by, bz, bw);

         glTexCoord2f(cs, ct);
		   glVertex4f(cx, cy, cz, cw);
      glEnd();
      glDisable(GL_TEXTURE_2D);
      return;*/
   }

/////////////////////////////////////
/////////////////////////////////////
/////////////////////////////////////
   if(colorCombine.func == GR_COMBINE_FUNCTION_SCALE_OTHER_MINUS_LOCAL_ADD_LOCAL &&
		colorCombine.factor == GR_COMBINE_FACTOR_TEXTURE_ALPHA &&
		colorCombine.other == GR_COMBINE_OTHER_TEXTURE &&
		colorCombine.local == GR_COMBINE_LOCAL_ITERATED)
   {
      //mario's face
      glDisable(GL_TEXTURE_2D);
      glDisable(GL_BLEND);
      glBegin(GL_TRIANGLES);
		   glColor4f(ar, ag, ab, aa);
		   glVertex4f(ax, ay, az, aw);

		   glColor4f(br, bg, bb, ba);
		   glVertex4f(bx, by, bz, bw);

		   glColor4f(cr, cg, cb, ca);
		   glVertex4f(cx, cy, cz, cw);
      glEnd();
      glEnable(GL_TEXTURE_2D);
   	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
      glEnable(GL_BLEND);
      glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	   glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
      glBegin(GL_TRIANGLES);
         glTexCoord2f(as, at);
		   glVertex4f(ax, ay, az, aw);

         glTexCoord2f(bs, bt);
		   glVertex4f(bx, by, bz, bw);

         glTexCoord2f(cs, ct);
		   glVertex4f(cx, cy, cz, cw);
      glEnd();
      glDisable(GL_TEXTURE_2D);
      if(!blend.enabled) glDisable(GL_BLEND);
      glBlendFunc(blend.rgb_sf, blend.rgb_df);

      return;
      /*glEnable(GL_TEXTURE_2D);
   	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL);
      glBegin(GL_TRIANGLES);
		   glColor4f(ar, ag, ab, aa);
         glTexCoord2f(as, at);
		   glVertex4f(ax, ay, az, aw);

		   glColor4f(br, bg, bb, ba);
         glTexCoord2f(bs, bt);
		   glVertex4f(bx, by, bz, bw);

		   glColor4f(cr, cg, cb, ca);
         glTexCoord2f(cs, ct);
		   glVertex4f(cx, cy, cz, cw);
      glEnd();
      glDisable(GL_TEXTURE_2D);
      return;*/
   }
 
/////////////////////////////////////
/////////////////////////////////////
/////////////////////////////////////
   if(colorCombine.func == GR_COMBINE_FUNCTION_SCALE_OTHER_MINUS_LOCAL_ADD_LOCAL &&
		colorCombine.factor == GR_COMBINE_FACTOR_LOD_FRACTION &&
		colorCombine.local == GR_COMBINE_LOCAL_CONSTANT &&
		colorCombine.other == GR_COMBINE_OTHER_ITERATED)
   {
      glEnable(GL_TEXTURE_2D);
   	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
      glBegin(GL_TRIANGLES);
         glTexCoord2f(as, at);
		   glColor4f(ar, ag, ab, aa);
		   glVertex4f(ax, ay, az, aw);
		   
         glTexCoord2f(bs, bt);
		   glColor4f(br, bg, bb, ba);
		   glVertex4f(bx, by, bz, bw);

         glTexCoord2f(cs, ct);
		   glColor4f(cr, cg, cb, ca);
		   glVertex4f(cx, cy, cz, cw);
	   glEnd();
      glDisable(GL_TEXTURE_2D);
      return;
   }

   glBegin(GL_TRIANGLES);
		glColor3f(1.0f, 0.0f, 0.0f);
		glVertex4f(ax, ay, az, aw);

		glColor3f(0.0f, 1.0f, 0.0f);
		glVertex4f(bx, by, bz, bw);

		glColor3f(0.0f, 0.0f, 1.0f);
		glVertex4f(cx, cy, cz, cw);
   glEnd();

   char string[256];
   char d[256];
   strcpy(string, "grColorCombine\n");
   strcat(string, itoa(colorCombine.func, d, 10));
   strcat(string, "\n");
   strcat(string, itoa(colorCombine.factor, d, 10));
   strcat(string, "\n");
   strcat(string, itoa(colorCombine.local, d, 10));
   strcat(string, "\n");
   strcat(string, itoa(colorCombine.other, d, 10));
   strcat(string, "\n");
   strcat(string, itoa(colorCombine.invert, d, 10));
   MessageBox(NULL, string, "Notice", MB_APPLMODAL);
   
   //MessageBox(NULL, "grDrawTriangle", "Notice", MB_APPLMODAL);
}