#include "stdafx.h"

extern "C" __declspec(dllexport)
FxU32 grTexTextureMemRequired(FxU32 evenOdd, GrTexInfo *info)
{
//#define GR_ASPECT_8x1 0x0       /* 8W x 1H */
//#define GR_ASPECT_4x1 0x1       /* 4W x 1H */
//#define GR_ASPECT_2x1 0x2       /* 2W x 1H */
//#define GR_ASPECT_1x1 0x3       /* 1W x 1H */
//#define GR_ASPECT_1x2 0x4       /* 1W x 2H */
//#define GR_ASPECT_1x4 0x5       /* 1W x 4H */
//#define GR_ASPECT_1x8 0x6       /* 1W x 8H */

//#define GR_LOD_256              0x0
//#define GR_LOD_128              0x1
//#define GR_LOD_64               0x2
//#define GR_LOD_32               0x3
//#define GR_LOD_16               0x4
//#define GR_LOD_8                0x5
//#define GR_LOD_4                0x6
//#define GR_LOD_2                0x7
//#define GR_LOD_1                0x8

	int height, width, i;
	int memNeeded = 0;

	if(info->largeLod > info->smallLod)
	{
		MessageBox(NULL, "wrong way", "Notice", MB_APPLMODAL);
		return 0;
	}

	for(i = info->largeLod; i <= info->smallLod; i++)
	{
		if(evenOdd == GR_MIPMAPLEVELMASK_EVEN && (i & 1) == 1) continue;
		if(evenOdd == GR_MIPMAPLEVELMASK_ODD  && (i & 1) == 0) continue;

		height = 2 << (8 - i);
		width = 2 << (8 - i);

		switch(info->aspectRatio)
		{
			case GR_ASPECT_8x1:
				height = height >> 3;
				break;
			case GR_ASPECT_4x1:
				height = height >> 2;
				break;
			case GR_ASPECT_2x1:
				height = height >> 1;
				break;
			case GR_ASPECT_1x1:
				break;
			case GR_ASPECT_1x2:
				width = width >> 1;
				break;
			case GR_ASPECT_1x4:
				width = width >> 2;
				break;
			case GR_ASPECT_1x8:
				width = width >> 3;
				break;
		}

		switch(info->format)
		{
		case GR_TEXFMT_8BIT:
		case GR_TEXFMT_YIQ_422:
		case GR_TEXFMT_ALPHA_8:
		case GR_TEXFMT_INTENSITY_8:
		case GR_TEXFMT_ALPHA_INTENSITY_44:
		case GR_TEXFMT_P_8:
			memNeeded += height * width;
			break;
		case GR_TEXFMT_16BIT:
		case GR_TEXFMT_AYIQ_8422:
		case GR_TEXFMT_RGB_565:
		case GR_TEXFMT_ARGB_1555:
		case GR_TEXFMT_ARGB_4444:
		case GR_TEXFMT_ALPHA_INTENSITY_88:
		case GR_TEXFMT_AP_88:
			memNeeded += 2 * height * width;
			break;
		}
	}

	return memNeeded;

   //MessageBox(NULL, "grTexTextureMemRequired", "Notice", MB_APPLMODAL);
}